
// Copyright (C) 2002 by Luigi Pino.  All Rights Reserved.

/***************************************************************************/

#define		Sphere_Radius					10.0f

// Controls
#define		Compete								4

// Game_position
#define		Game_Intro						0
#define		Game_Menu							1
#define		Game_Play							2
#define		Game_Ending						3

// Game_type
#define		Timed									0
#define		Countdown							1
#define		High_Score						2

// Textures
#define		Texture_Total					13
#define		t_font								0
#define		t_font_mask						1
#define		t_menu_1							2
#define		t_menu_2							3
#define		t_menu_3							4
#define		t_menu_mask_1					5
#define		t_menu_mask_2					6
#define		t_inside_ground				7
#define		t_side_wall						8
#define		t_net_wall						9
#define		t_paddle							10
#define		t_arrow								11
#define		t_sphere							12

/***************************************************************************/

typedef struct {
	float	distance_current;
	float	distance_destination;
	float	rotate_current;
	float	rotate_destination;
} Light_Values_Struct;

typedef struct {
	bool	game_end_fade;																// Fade to end menu
	bool	game_start_fade;															// Fade to game
	bool	sound;																				// Whether sound is on or off
	float	fade_amount;																	// Used for fading
	float	intro_count;																	// Used for intro animation
	float	paddle_speed;																	// Speed of paddle
	float	seconds_left;																	// Time left in game if chosen
	float	sphere_speed;																	// Speed of sphere - lower is faster
	float	wall_height;																	// Height of walls
	int		game_position;																// Intro, Menu, Play, Ending
	int		game_type;																		// Timed, Countdown, High_Score
	int		player_number;																// Number of player
	int		sphere_number;																// Number of spheres
} Values_Struct;

/***************************************************************************/

void Game();

void Update_Mouse();

/***************************************************************************/