
// Copyright (C) 2002 by Luigi Pino.  All Rights Reserved.

/***************************************************************************/

class Window_Class {
	public:
		Window_Class(int texture_size);										// Constructor
		~Window_Class();																	// Deconstructor

		bool		CreateGLWindow(char *title, int width, int height, int bits, bool fullscreenflag);
		void		Font_Begin();
		void		Font_End();
		float		Font_Char(char *word, float x, float y, float size, float r, float g, float b);
		float		Font_Float(double number, int precision, float x, float y, float size, float r, float g, float b);
		float		Font_Int(int number, float x, float y, float size, float r, float g, float b);
		float		Font_Time(bool show_hours, bool show_minutes, bool show_seconds, bool show_micro_seconds,
											float total_seconds, float x, float y, float size, float r, float g, float b);
		float2	Font_Position(int letter);
		float		Font_Print_Texture(char *word, float x, float y, float size, float r, float g, float b);
		GLuint	Get_Texture(int index);
		void		Initialize_GL();
		void		KillGLWindow();
		void		Load_Texture(int index, char *name);
		void		Process_Messages();

		bool		keys[256];																// Keyboard array
		bool		active;																		// Whether program is active
		bool		quit_game;																// Quit program flag
		float		zFar;																			// Z buffer far boundary
		float		zNear;																		// Z buffer near boudary
		HDC			hDC;																			// Private GDI device context
		int			polygon_number;														// Amount of polygon in frame
		int			screen_height;														// Screen resolution height
		int			screen_width;															// Screen resolution width
		MSG			msg;																			// Message structure

	private:
		bool						fullscreen;												// Fullscreen flag
		GLuint					*texture;													// Texture pointer
		HGLRC						hRC;															// Permanent rendering context
		HWND						hWnd;															// Window handle
		HINSTANCE				hInstance;												// Instance of program
};

/***************************************************************************/